
#include<stdlib.h>
#include<string.h>
#include<stdio.h>
typedef struct
{
char parola[20];
}element;

typedef struct nodo

{
	element value;
	struct nodo*left,*right;
}nodeTree;
typedef nodeTree*tree;

int fcmp(const void*a,const void*b)
{
	element e,f;
	e=*(element*)a;
	f=*(element*)b;
	if(strcmp(e.parola,f.parola)<0)return -1;
	else if(strcmp(e.parola,f.parola)>0)return 1;
	else return 0;
}

tree cons_tree(element parola,tree l,tree r)
{
	tree t;
	t=(tree)malloc(sizeof(nodeTree));
	t->value=parola;
	t->left=l;
	t->right=r;
	return t;
}
tree ordins(element e,tree t)
{
	if(t==NULL) return cons_tree(e,NULL,NULL);
	else if(strcmp(e.parola,t->value.parola)<=0)
		t->left=ordins(e,t->left);
	else t->right=ordins(e,t->right);
	return t;
}
int member(element e,tree t)
{
	if(t==NULL) return 0;
	else if(strcmp(e.parola,t->value.parola)==0)return 1;
	else if(strcmp(e.parola,t->value.parola)<0)return member(e,t->left);
	else return member(e,t->right);
}
void inorder(tree t)
{
	if(t!=NULL)
	{
		inorder(t->left);
		printf("%s\n",t->value.parola);
		inorder(t->right);
	}
}
tree funzioneA(FILE*fp1,FILE*fp2,tree t)
{
	element parola1,parola2;
	int trovato=0;
	while(fread(&parola1,sizeof(element),1,fp1)>0)
	{
		rewind(fp2);
		trovato=0;
		while((fread(&parola2,sizeof(element),1,fp2)>0) && (!trovato))
		{
			if(strcmp(parola1.parola,parola2.parola)==0)
				trovato=1;
		}	
		if(trovato==0)
			{
				t=ordins(parola1,t);
				trovato=1;
			}
	}
	rewind(fp1);
	return t;
}
int ricerca(element V[],element e,int DIM)
{
	int trovato=0;
	int i=0;
	while(i<DIM && !trovato)
	{
		if(strcmp(e.parola,V[i].parola)==0)
			trovato=1;
		i++;
	}
	return trovato;
}

int nnodes(tree t)
{
	if(t==NULL) return 0;
	else return 1+nnodes(t->left)+nnodes(t->right);
}
void funzioneB(FILE*fp,tree t)
{
	int n=nnodes(t);
	fprintf(fp,"Il numero dei nodi risulta %d\n",n);
}

void funzioneC(FILE*fp1,FILE*fp2,element V[],int DIM,tree t)
{
	element e;
	int i=0;
	int n=1;
	while(fread(&e,sizeof(element),1,fp1)>0 &&i<DIM)
	{
		if(ricerca(V,e,n)==0)
			{
				V[i]=e;
				i++;
				n++;
		    }
	}
	qsort(V,DIM,sizeof(element),fcmp);
	i=0;
	while(i<DIM)
	{
		if(member(V[i],t)==1)
		{
		fprintf(fp2,"%s\n",V[i].parola);
		}
		i++;
	}
}

	
main()
{
	FILE*fp1,*fp2,*fp3,*fp4;
	tree t=NULL;
	element V[10];
	int i;
	fp1=fopen("parole1.bin","rb");
	if(fp1==NULL)printf("ERROR\n");
	fp2=fopen("parole2.bin","rb");
	if(fp2==NULL)
	{
		printf("ERROR2\n");
		exit(-1);
	}
	t=funzioneA(fp1,fp2,t);
	printf("Contenuto albero:\n\n");
	inorder(t);
	fclose(fp2);
	fp3=fopen("uscita.txt","wt");
	if(fp3==NULL)
	{
		printf("ERROR3\n");
		exit(-1);
	}
	funzioneB(fp3,t);
	fclose(fp3);
	fp4=fopen("outputAB.txt","wt");
	if(fp4==NULL)
	{
		printf("ERROR4\n");
		exit(-1);
	}
	funzioneC(fp1,fp4,V,10,t);
	printf("\nContenuto array\n\n");
	for (i=0;i<10;i++)
		printf("%s\n",V[i].parola);
	fclose(fp1);
	fclose(fp4);
}